//! @file $RCSfile: slave_lin.h,v $
//!
//! Copyright (c) 2004 Atmel.
//!
//! ۸т̎gpATMEL̍ŏIgpҋ_񂪕KvłB
//! 쌠ʒmɂĂlicense.txtǂłB
//!
//! @brief ̧قCĳ ۸яp̐`łB
//!
//! ̐`̧ق͎pDoxygenɂĉ͂邱Ƃł܂B
//! Ȃ۸т̿ĳ\ł̧̂ق̋@\ɒuĂB
//!
//! @version $Revision: 1.1.1.1 $ $Name: First_Release $ $Id: slave_lin.h,v 1.1.1.1 2006/07/27 09:39:53 gallain Exp $
//!
//! @todo
//! @bug

#ifndef SLAVE_LIN_H
#define SLAVE_LIN_H

//_____ ݸٰ ________________________________________________________________
#include "config.h"
#include "lib_mcu/lin_uart/lin_lib.h"
#include "lib_mcu/lin_uart/lin_drv_usart.h"
#include "lib_mcu/timer/timer0_lib.h"
#include "lib_mcu/timer/timer1_lib.h"
#include "lib_mcu/timer/timer2_lib.h"
#include "lib_mcu/lin_uart/runtime_calibration_lib.h"

//_____ ϸ ____________________________________________________________________

#ifndef LIN_BAUDRATE
#error You must define LIN_BAUDRATE in config.h
#endif

#if LIN_BAUDRATE == 2400
#define _8MHZ_TCNT1H			0xF3		// 1ޯĎԂň/l
#define _8MHZ_TCNT1L			0x00
#define _8_BIT_TIMER_PRESCALER	64
#define _8_BIT_TIMER_SEED		204
#elif LIN_BAUDRATE == 9600
#define _8MHZ_TCNT1H			0xFC
#define _8MHZ_TCNT1L			0xC0
#define _8_BIT_TIMER_PRESCALER	8
#define _8_BIT_TIMER_SEED		152
#elif LIN_BAUDRATE == 19200
#define _8MHZ_TCNT1H			0xFE
#define _8MHZ_TCNT1L			0x60
#define _8_BIT_TIMER_PRESCALER	8
#define _8_BIT_TIMER_SEED		204
#else
#error " GIVEN LIN BAUDRATE IS NOT SUPPORTED (CONFIG.H) "
#endif

#define ASCII_NUM_OFFSET		48
#define SLEEP_TIMOUT			25000
#define NB_FRAME				3
#define UNKWNON_LIN_FRAME_TYPE	2				// m̎ʎq
#define REMOTE_LIN_FRAME_TYPE	1				// 呕uM(擪)+呕uM()
#define STANDART_LIN_FRAME_TYPE	0				// 呕uM(擪+)

//_____ 錾 ___________________________________________________________________

//!< LINڰэ\
typedef struct  {
  U8 frame_id;
  U8 frame_size;
  U8 * frame_data;
  U8 frame_type;								// 1ȂA呕uM(擪)+呕uM()
} t_frame;

//!< LINv敔\
typedef struct  {
  U8 number_of_frame;
  t_frame frame_message[NB_FRAME];
} t_schedule;

extern t_schedule my_schedule;			//!< ݂̌v
extern U8 tab_data[8];					//!< LINްɏՕ

#ifdef _SLEEP_TIMOUT_DETECTION
extern U8  LINSleepFlag;				// LINx~׸
extern U8  MyCpuIsSleepingFlag;			// MCUx~쒆׸
extern U8  NoBusActivityFlag;			// (2500ޯĎ)޽Ȃ׸
extern U16 SleepCtr;					// x~Ԓߌv
#endif

#ifdef _RUN_TIME_RC_CALIBRATION_ENABLE
extern volatile U8 Timer_IC_cnt;
extern volatile U8 osccal_start;
extern volatile U8 _lin_synchronized;	// LIN͎呕uƓ܂B(1=2%)
#endif

#ifdef _COUNTING_ERRORS_ENABLE
extern U16 countCERR;					// ьv
extern U16 countRERR;					// ]uُv(呕û)
extern U16 countBERR;					// ޯĈُv평
extern U16 countSERR;					// ُv평
extern U16 countPERR;					// èv
#endif

void LIN_TIMER_init (void);
void DataRequest_Notification(void);
void DataReceived_Notification(U8 ReceivedId,U8 ReceivedSize);
void StartLinSlave (void);
int IdReceived_Notification(U8 ReceivedId,U8 ExpectedSize);
U8 l_sch_tick(void);					// ޯĎԒPʽޭ׊Ǘ
U8 id_to_dlc (U8 lin_id);
char int2hex(unsigned char integer) ;

#ifdef _COUNTING_ERRORS_ENABLE
void update_error_counter(U8 status);
#endif

#endif /* end #ifndef SLAVE_LIN_H */
